$$.widget = {
  name: 'ADC Sensor',
  version: '1.0',
  author: 'Marco Franchi',
  release: '2016-07-17',
  icon: 'pages/control/widgets/homegenie/generic/images/sensor.png'
};

var paramTemplate = null;
var paramIndex = 0;
var tickerTimeout = null;
var updateTime = '';
var ValueMax = 0;
var ValueMin = 0;

$$.onStart = function() {
  // Settings button click
  $$.field('settings').on('click', function () {
    $$.ui.EditModule($$.module);
  });
  for (p = 0; p < $$.module.Properties.length; p++) {
    var parameter = $$.module.Properties[p];
    if (parameter.Name.slice(0,7) == 'MCP3008') {
      ValueMax=parameter.Value;
      ValueMin=parameter.Value;
    }
  }
}

$$.onRefresh = function () {
  // Refresh UI fields
  $$.field('name').html($$.module.Name);
  $$.field('param-value').html("Waiting...");
  $$.field('description').html(($$.module.Domain.substring($$.module.Domain.lastIndexOf('.') + 1)) + ' ' + $$.module.Address);
  $$.refreshStatus();
}

$$.onUpdate = function(parameter, value) {
  switch(parameter) {
    case 'Status.Error':
      if (value != '' && $$.field('led').length)
        $$.field('led').attr('src', 'images/common/led_red.png');
      break;
    default:
      $$.signalActity();
      $$.refreshParams();
      $$.focusParam(parameter);
      $$.refreshStatus();
  }
}

$$.onStop = function() {
  // TODO: ..
}


$$.refreshStatus = function() {
  $$.ui.GetModuleIcon($$.module, function(imgPath){
    $$.field('icon').attr('src', imgPath);
    $$.widget.icon = imgPath;
  });
  var d = new Date(updateTime.replace(' ', 'T'));
  if (updateTime != '')
     $$.field('updatetime').html($$.util.FormatDate(d) + ' ' + $$.util.FormatDateTime(d));
}

$$.focusParam = function(paramName) {
  // TODO: ..
}

$$.refreshParams = function() {
  for (p = 0; p < $$.module.Properties.length; p++) {
    var parameter = $$.module.Properties[p];
    if (parameter.Name.slice(0,7) == 'MCP3008') {
      $$.field('param-value').html(parameter.Value + parameter.Name.slice(8,parameter.Name.length));
      if (parameter.Value > ValueMax) ValueMax=parameter.Value;
      if (parameter.Value < ValueMin) ValueMin=parameter.Value;
      if (updateTime < parameter.UpdateTime)
         updateTime = parameter.UpdateTime;
    }
  }
  $$.field('MinMax').html("Max: " + ValueMax + " Min: " + ValueMin);
}